# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.

#Taken from automake script 
$AM_INIT_AUTOMAKE_PATTERN = "AM_INIT_AUTOMAKE\\([^,]*,([^,)]+)[,)]";
$AM_PACKAGE_VERSION_PATTERN = "^\\s*\\[?([^]\\s]+)\\]?\\s*\$";

$home_dir = $ENV{HOME};
$items_file = $home_dir . "/.titano/.items";

open(ITEMS,$items_file) || die "Items file not found: \"$items_file\": nothing to do.\n";

@files = ("_configure.in","_AUTHORS","src/_Makefile.am");

#read data
%subst;

$oper = <ITEMS>;
chomp($oper);
$dir = <ITEMS>;
chomp($dir);
$subst{DIR} = $dir;
$name = <ITEMS>;
chomp($name);
$subst{NAME} = $name;
$fullfile = $dir . "/" . $name;
$subst{DIR} = $fullfile;
$templ_file = <ITEMS>;
chomp($templ_file);
$script_dir = <ITEMS>;
chomp($script_dir);

while(<ITEMS>){
        chomp;
	$foo = <ITEMS>;
	chomp($foo);
        $subst{$_} = $foo;
};

close(ITEMS);

$subst{YEAR} = `date +%Y`;
$subst{UNAME} = $subst{NAME};
$subst{UNAME} =~ tr/a-z\-/A-Z_/;
$subst{LNAME} = $subst{UNAME};
$subst{LNAME} =~ tr/A-Z\-/a-z_/;

if($oper eq "install"){
	print "Creating project directory...\n";
	mkdir($fullfile,0755);
	print "Changing to project directory...\n";
	chdir($fullfile);
	print "Untarring project template...\n";
	system("tar -xzf $templ_file") && die "Couldn't untar project template: $templ_name\n";
    
	print "Preparing project...\n";
	foreach $i (@files){
		$ii = $i;
		substr($ii,rindex($ii,"_"),1) = "";
		process_file($i,$ii);
	};

	process_file("project.titano","$name.titano");

	print "Cleaning...\n";
	foreach $i (@files){
		unlink($i);
	};
	unlink("project.titano");
}else{
	print "Changing to project directory...\n";
	chdir($dir);
	
	print "Getting information about project...\n";
	open(CONF,"configure.in") || die "No configure.in found\n";
	
	$name = "Project";
	$subst{VERSION} = "0.0.1";
	
	while(<CONF>){
	    chomp;
	    if (/$AM_INIT_AUTOMAKE_PATTERN/o){
		    $foo = $_;
		    $foo =~ s/[A-Z0-9_(\s]*,\s*//i;
		    $foo =~ s/(\s)*\)\s*//; 
    		    $subst{VERSION} = $foo;
		    @s = split(/[(\s*\(\s*)(\s*\)\s*)(\s*,\s*)(\s+)]/);
		    $name = $s[1];
	    };
	};
	
	$subst{NAME} = $name;
	$subst{DIR} = $dir;
	$subst{UNAME} = $subst{NAME};
	$subst{UNAME} =~ tr/a-z\-/A-Z_/;
	$subst{LNAME} = $subst{UNAME};
	$subst{LNAME} =~ tr/A-Z\-/a-z_/;
	
	print "Untarring project file...\n";
	system("tar -xzf $templ_file project.titano") && die "Couldn't untar project template: $templ_name\n";
	process_file("project.titano","$name.titano");
	
	print "Adding sources...\n";
	open(FILES,"$script_dir/amlist $dir/|") || die "Couldn't find amlist\n";
	open(PROJ,">>$name.titano");
	
	print PROJ "\n";
	while(<FILES>){
		chomp;
		print PROJ "$_=false\n";
	};
	print "Cleaning...\n";
	unlink("project.titano");
};
	
print "Done.\n";

sub substitute
{
	foreach $i (keys(%subst)){
		$_[0] =~ s/\#$i\#/$subst{$i}/;
	};
}

sub process_file
{
	open(FILE,">$_[1]") || die "Couldn't create file: \"$_[1]\": nothing to do.";
	open(TEMPL,$_[0]) || die "Template not found: \"$_[0]\": nothing to do.";

	while($foo = <TEMPL>){
		substitute($foo);
		print FILE $foo;
	};	
	
	close(TEMPL);
	close(FILE);
	
}